commit 18dbe4cc1416ea3b41c24aeba18ddc45638b9a98
Author: freddy77 <freddy77>
Date:   Sun May 2 11:52:13 2010 +0000

    fix unmatched parenthesis (patch from Mark Brand) and minor memory leaks

diff --git a/ChangeLog b/ChangeLog
index 015df49..cdc757f 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Sun May  2 13:52:05 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/mem.c:
+	- fix unmatched parenthesis (patch from Mark Brand) and minor
+	  memory leaks
+
 Fri Apr 30 17:57:22 EDT 2010	JK Lowden <jklowden@freetds.org>
 	* src/tds/mem.c initilize client charset per setlocale(3) and friends
 
@@ -2413,4 +2418,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3013 2010/04/30 21:59:42 jklowden Exp $
+$Id: ChangeLog,v 1.3014 2010/05/02 11:52:13 freddy77 Exp $
diff --git a/src/tds/mem.c b/src/tds/mem.c
index 4624330..1977c19 100644
--- a/src/tds/mem.c
+++ b/src/tds/mem.c
@@ -53,7 +53,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: mem.c,v 1.197 2010/04/30 21:59:43 jklowden Exp $");
+TDS_RCSID(var, "$Id: mem.c,v 1.198 2010/05/02 11:52:13 freddy77 Exp $");
 
 static void tds_free_env(TDSSOCKET * tds);
 static void tds_free_compute_results(TDSSOCKET * tds);
@@ -696,26 +696,33 @@ tds_alloc_locale(void)
 
 	TEST_MALLOC(locale, TDSLOCALE);
 
-	locale->client_charset = strdup("ISO-8859-1"); 
-	
 #if HAVE_NL_LANGINFO && defined(CODESET)
-	locale->client_charset = nl_langinfo(CODESET);
+	locale->client_charset = strdup(nl_langinfo(CODESET));
 #else
-	if ((lc_all = strdup(setlocale(LC_ALL, NULL)) == NULL)
+	locale->client_charset = strdup("ISO-8859-1");
+	if (!locale->client_charset)
+		goto Cleanup;
+
+	if ((lc_all = strdup(setlocale(LC_ALL, NULL))) == NULL)
 		goto Cleanup;
 
 	if (strtok(lc_all, ".")) {
 		char *encoding = strtok(NULL, "@");
 		if (encoding) {
+			free(locale->client_charset);
 			locale->client_charset = strdup(encoding);
 		}
 	}
+	free(lc_all);
 #endif
+	if (!locale->client_charset)
+		goto Cleanup;
 	tdsdump_log(TDS_DBG_FUNC, "tds_alloc_locale(): initialized locale to \"%s\"\n", locale->client_charset? locale->client_charset : "NULL");
 
 	return locale;
 
       Cleanup:
+	tds_free_locale(locale);
 	return NULL;
 }
 static const unsigned char defaultcaps[] = { 

